CAD开发者社区

 找回密码
 立即注册

QQ登录

只需一步,快速开始

ActiveX 开发指南

相关分类

Rotate3D Method (ActiveX)

2023-1-4 04:07| 发布者: admin| 查看: 585| 评论: 0|来自: AutoCAD

摘要: 绕 3D 轴旋转对象。点 1 和点 2 定义成为旋转轴的线。

绕 3D 轴旋转对象。点 1 和点 2 定义成为旋转轴的线。

支持的平台:仅窗口

签名

工 务 局:

object.Rotate3D Point1, Point2, RotationAngle
对象

类型:所有图形对象属性引用尺寸

此方法适用的对象。

要点1

访问:仅输入

类型:变体(双精度的三元素数组)

指定轴线第一个点的 3D WCS 坐标。

要点2

访问:仅输入

类型:变体(双精度的三元素数组)

指定轴线第二个点的 3D WCS 坐标。

旋转角度

访问:仅输入

类型:

以弧度为单位,用于围绕选定轴旋转对象的角度。

返回值(RetVal)

无返回值。

言论



例子

工 务 局:

Sub Example_Rotate3D()
    ' This example creates a box in model space.
    ' It then rotates the box about an axis.
        
    Dim boxObj As Acad3DSolid
    Dim length As Double, width As Double, height As Double
    Dim center(0 To 2) As Double
    
    ' Define the box
    center(0) = 5#: center(1) = 5#: center(2) = 0
    length = 5#: width = 7: height = 10#
    
    ' Create the box (3DSolid) object in model space
    Set boxObj = ThisDrawing.ModelSpace.AddBox(center, length, width, height)
    
    ' Change the viewing direction of the viewport
    Dim NewDirection(0 To 2) As Double
    NewDirection(0) = -1: NewDirection(1) = -1: NewDirection(2) = 1
    ThisDrawing.ActiveViewport.direction = NewDirection
    ThisDrawing.ActiveViewport = ThisDrawing.ActiveViewport
    ThisDrawing.Regen True
        
    ' Define the rotation axis with two points
    Dim rotatePt1(0 To 2) As Double
    Dim rotatePt2(0 To 2) As Double
    Dim rotateAngle As Double
    
    rotatePt1(0) = -3: rotatePt1(1) = 4: rotatePt1(2) = 0
    rotatePt2(0) = -3: rotatePt2(1) = -4: rotatePt2(2) = 0
    rotateAngle = 30
    rotateAngle = rotateAngle * 3.141592 / 180#
    
    ' Draw a line between the two axis points so that it is visible.
    ' This is optional. It is not required for the rotation.
    Dim axisLine As AcadLine
    Set axisLine = ThisDrawing.ModelSpace.AddLine(rotatePt1, rotatePt2)
    axisLine.Update
    MsgBox "Rotate the box 30 degrees about the axis shown.", , "Rotate3D Example"

    ' Rotate the box
    boxObj.Rotate3D rotatePt1, rotatePt2, rotateAngle
    ThisDrawing.Regen True
    MsgBox "The box is rotated 30 degrees.", , "Rotate3D Example"
    
End Sub

Visual LISP:

(vl-load-com)
(defun c:Example_Rotate3D()
    ;; This example creates a box in model space.
    ;; It then rotates the box about an axis.
    (setq acadObj (vlax-get-acad-object))
    (setq doc (vla-get-ActiveDocument acadObj))

    ;; Define the box
    (setq center (vlax-3d-point 5 5 0)
          boxLength 5
	         boxWidth 7
	         boxHeight 10)
    
    ;; Create the box (3DSolid) object in model space
    (setq modelSpace (vla-get-ModelSpace doc))
    (setq boxObj (vla-AddBox modelSpace center boxLength boxWidth boxHeight))
    
    ;; Change the viewing direction of the viewport
    (setq NewDirection (vlax-3d-point -1 -1 1))
    (setq activeViewport (vla-get-ActiveViewport doc))
    (vla-put-Direction activeViewport NewDirection)
    (vla-put-ActiveViewport doc activeViewport)
    (vla-ZoomAll acadObj)
        
    ;; Define the rotation axis with two points
    (setq rotatePt1 (vlax-3d-point -3 4 0)
          rotatePt2 (vlax-3d-point -3 -4 0)
          rotateAngle (/ (* 30 3.141592) 180))
    
    ;; Draw a line between the two axis points so that it is visible.
    ;; This is optional. It is not required for the rotation.
    (setq axisLine (vla-AddLine modelSpace rotatePt1 rotatePt2))
    (vla-Update axisLine)
    (alert "Rotate the box 30 degrees about the axis shown.")

    ;; Rotate the box
    (vla-Rotate3D boxObj rotatePt1 rotatePt2 rotateAngle)
    (vla-Regen doc :vlax-true)
    (alert "The box is rotated 30 degrees.")
)

路过

雷人

握手

鲜花

鸡蛋

最新评论

QQ|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 )

GMT+8, 2024-5-12 18:09

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

返回顶部